/*********************************************************************************
**
**   $Id: VendorForm.cpp,v 1.2 2004/04/03 14:04:53 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qlistbox.h>
#include <qmessagebox.h>
#include <qregexp.h>
#include <qsqlquery.h>
#include "VendorForm.h"

extern QSqlDatabase *autohouse;

VendorForm::VendorForm(QWidget *pParent, const char *pName, WFlags f) :
           DataForm(autohouse, "vendors", 7, 6, pParent, pName, f)
{
   printf("VendorForm::VendorForm(): Enter()\n");
   fflush(stdout);

   inTransaction = false;

   nameEdit =     new QLineEdit(this);
   activeSelect = new YesNoSelect(this);
   
   DataFields fields[] =
   {
      { "name",      "Name",           0,  0,  2,  0,  0,    0,   0, "",   nameEdit, NULL },
      { "Active",    "Active",         0,  3,  1,  0,  0,    0,   0, "",   activeSelect, "yesno" },
      { "contact",   "Contact",        1,  0,  3,  0,  0,    0,   0, "",   NULL, NULL },
      { "account1",  "Account#",       2,  0,  3,  0,  0,    0,   0, "",   NULL, NULL },
      { "address1",  "Addr 1",         3,  0,  3,  0,  0,    0,   0, "",   NULL, NULL },
      { "address2",  "Addr 2",         4,  0,  3,  0,  0,    0,   0, "",   NULL, NULL },
      { "city",      "City",           5,  0,  0,  0,  0,    0,   0, "",   NULL, NULL },
      { "state",     "State",          5,  1,  0,  0,  3,    3,   0, "TX", NULL, NULL },
      { "zipcode",   "Zip",            5,  2,  0,  0,  8,   10,   0, "",   NULL, NULL },
      { "phone1",    "Phone 1",        6,  0,  0,  0,  7,    0,   0, "",   NULL, NULL },
      { "phoe2",     "Phone 2",        6,  1,  0,  0,  7,    0,   0, "",   NULL, NULL },
      { "fax",       "Fax",            6,  2,  0,  0,  7,    0,   0, "",   NULL, NULL },
      { "url",       "URL",            7,  0,  3,  0,  0,    0,   0, "",   NULL, NULL },
      { "email",     "EMail",          8,  0,  3,  0,  0,    0,   0, "",   NULL, NULL },
      {  NULL, NULL, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, NULL }
   };
   printf("VendorForm::VendorForm(): Setting Fields()\n");
   fflush(stdout);
   setFields(fields);
   printf("VendorForm::VendorForm(): Exit()\n");
   fflush(stdout);
}

void VendorForm::deleteRecord() 
{
   QString s;
   printf("VendorForm::deleteRecord(): Enter()\n");
   fflush(stdout);
   s = "Deletng vendor '" +
        nameEdit->text() +
        "'. This operation cannot be undone, Are you sure?"; 
   printf("VendorForm::deleteRecord(): Opening Message Box\n");
   fflush(stdout);
   if (QMessageBox::warning(NULL, "Delete Transaction", s, QMessageBox::Yes | QMessageBox::Default, 
                           QMessageBox::No | QMessageBox::Escape) == QMessageBox::Yes) 
   {
      printf("VendorForm::deleteRecord(): deleting record()\n");
      fflush(stdout);
      DataForm::deleteRecord();
   }
   printf("VendorForm::deleteRecord(): Exit()\n");
   fflush(stdout);
}

void VendorForm::insertRecord()
{
   beginTransaction();
   DataForm::insertRecord();  
}

void VendorForm::updateRecord()
{
   beginTransaction();
   DataForm::updateRecord();  
}

void VendorForm::beginTransaction()
{
   if ( ! inTransaction ) 
   {
      DataForm::beginTransaction();
      inTransaction = true;
   }
}

void VendorForm::commitTransaction()
{
   if ( inTransaction ) 
   {
      DataForm::commitTransaction();
      inTransaction = false;
   }
}

void VendorForm::rollbackTransaction()
{
   if ( inTransaction ) 
   {
      DataForm::rollbackTransaction();
      inTransaction = false;
   }
}

bool VendorForm::isInTransaction()
{
   printf("VendorForm::isInTransaction(): inTransaction = %x\n", inTransaction);
   fflush(stdout);
   return(inTransaction);
}

