/*********************************************************************************
**
**   $Id: p2vedit.ui.h,v 1.2 2004/07/10 14:06:51 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qmessagebox.h>

void P2VEdit::initialize()
{
   P2VTable->refresh();
   P2VTable->selectRow(0);
}

/**********************************************************************/
/*   This  member  function  adds a record to the Parts2Vendor table  */
/*   representative of the selected row in the VendorTable            */
/**********************************************************************/
void P2VEdit::addVendor()
{
   QSqlRecord *r = VendorTable->currentRecord();
   if ( r ) 
   {
      QString v = r->value("ident").toString();
      QString p;
      p.setNum(part);
      QString sql = "insert into part2vendor (part, vendor) values ('" + p + "', '" + v + "')";
      QSqlQuery q(sql);
      if ( !q.isActive() ) 
      {
         QMessageBox::warning(NULL, "Error!", "Error adding Vendor: \n" + q.lastError().driverText() + q.lastError().databaseText(), "Okay");
         return;
      }
      P2VTable->refresh();
   }
}

/**********************************************************************/
/*   This   member  function  removes  the  selected  row  from  the  */
/*   Parts2Vendor Table                                               */
/**********************************************************************/
void P2VEdit::removeVendor()
{
   QSqlRecord *r = P2VTable->currentRecord();
   if ( r ) 
   {
      QString ident = r->value("p2v").toString();
      QString sql = "delete from part2vendor where ident = '" + ident + "'";
      QSqlQuery q(sql);
      if ( !q.isActive() ) 
      {
         QMessageBox::warning(NULL, "Error!", "Error removing Vendor: \n" + q.lastError().driverText() + q.lastError().databaseText(), "Okay");
         return;
      }
      P2VTable->refresh();
   }
}


void P2VEdit::setPart( int p )
{
   part = p;
   QString sp;
   sp.setNum(p);
   QString f;
   f = "part = '" + sp + "'";
   P2VTable->setFilter(f);
   P2VTable->refresh();
}
